/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/tinderbox/XR-Trunk/Darwin_8.8.4_Depend/mozilla/security/manager/ssl/public/nsICertOverrideService.idl
 */

package org.mozilla.interfaces;

/**
 * This represents the global list of triples
 *   {host:port, cert-fingerprint, allowed-overrides} 
 * that the user wants to accept without further warnings. 
 */
public interface nsICertOverrideService extends nsISupports {

  String NS_ICERTOVERRIDESERVICE_IID =
    "{7e646227-485d-49c6-8e37-e2c62cb204e1}";

  /**
   *  Override Untrusted
   */
  short ERROR_UNTRUSTED = 1;

  /**
   *  Override hostname Mismatch
   */
  short ERROR_MISMATCH = 2;

  /**
   *  Override Time error
   */
  short ERROR_TIME = 4;

  /**
   *  The given cert should always be accepted for the given hostname:port,
   *  regardless of errors verifying the cert.
   *  Host:Port is a primary key, only one entry per host:port can exist.
   *  The implementation will store a fingerprint of the cert.
   *  The implementation will decide which fingerprint alg is used.
   *
   *  @param aHostNameWithPort The host:port this mapping belongs to
   *  @param aCert The cert that should always be accepted
   *  @param aOverrideBits The errors we want to be overriden
   */
  void rememberValidityOverride(String aHostNameWithPort, nsIX509Cert aCert, long aOverrideBits);

  /**
   *  The given cert should always be accepted for the given hostname:port,
   *  regardless of errors verifying the cert.
   *  Host:Port is a primary key, only one entry per host:port can exist.
   *  The implementation will store a fingerprint of the cert.
   *  The implementation will decide which fingerprint alg is used.
   *
   *  @param aHostNameWithPort The host:port this mapping belongs to
   *  @param aCert The cert that should always be accepted
   *  @param aOverrideBits The errors that are currently overriden
   *  @return whether an override entry for aHostNameWithPort is currently on file
   *          that matches the given certificate
   */
  boolean hasMatchingOverride(String aHostNameWithPort, nsIX509Cert aCert, long[] aOverrideBits);

  /**
   *  Retrieve the stored override for the given hostname:port.
   *
   *  @param aHostNameWithPort The host:port whose entry should be tested
   *  @param aHashAlg On return value True, the fingerprint hash algorithm
   *                  as an OID value in dotted notation.
   *  @param aFingerprint On return value True, the stored fingerprint 
   *  @param aOverrideBits The errors that are currently overriden
   *  @return whether a matching override entry for aHostNameWithPort 
   *          and aFingerprint is currently on file
   */
  boolean getValidityOverride(String aHostNameWithPort, String[] aHashAlg, String[] aFingerprint, long[] aOverrideBits);

  /**
   *  Remove a stored override for the given hostname:port.
   *
   *  @param aHostNameWithPort The host:port whose entry should be cleared.
   */
  void clearValidityOverride(String aHostNameWithPort);

  /**
   *  Obtain the full list of hostname:port for which overrides are stored.
   *
   *  @param aCount The number of host:port entries returned
   *  @param aHostsWithPortsArray The array of host:port entries returned
   */
  void getAllOverrideHostsWithPorts(long[] aCount, String[][] aHostsWithPortsArray);

  /**
   *  Is the given cert used in rules?
   *
   *  @param aCert The cert we're looking for
   *  @return how many override entries are currently on file
   *          for the given certificate
   */
  long isCertUsedForOverrides(nsIX509Cert aCert);

}